/* Boilerplate for a daemon */

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <syslog.h>


int main(int argc, char *argv[]) 
{ 
    int i,pid,  verbose=1; 
    time_t timeval; 
    int log_fd;

    /* check that enough commandline args have been passed */
    if(argc <1){
	printf("Daemon Boilerplate\n Usage: %s <log_file_name>\n",argv[0]);
	}

    /* open logfile*/
    log_fd=open(argv[1],O_CREAT|O_RDWR,S_IRUSR|S_IWUSR);
    if(log_fd <0){
	perror("cannot create logfile");
	exit(-1);
	}

    daemon(1,0); /*nochdir = 1, noclose = 0*/
    dup2(log_fd,STDOUT_FILENO);
    openlog("log_tester",LOG_PID,LOG_USER);
   
    while (1) {
        write(log_fd,"I am the father\n",16);
        pid = fork();       
        if (pid < 0) {
          perror("Issues in spawning listener child");
          return -1;
        }
        if(pid==0){
           printf("I am the child!");
           sleep(10);
           exit(0);
        } else {
          int retval=0;
          wait(&retval);
          syslog(LOG_ERR,"My child %d just terminated!",pid); 
        }
    }

    closelog();
    /* should never get here during regular operation */ 
    exit(-1); 
    return -1;
} 
